%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Task_Convert_Joint_Topology(Convert_Mesh_From, Convert_Mesh_To, Quad_RBE2_Stiffen_Strategy, Bar_Spider_PSet_Name)

global ErrCode;

global DB_FASTENERS;

if (size(DB_FASTENERS,1) == 0)
    fprintf (1, 'Пустая база данных крепежа!\n');
    ErrCode = -1;
    return;
end

% Инициализация счетчиков

Converted_JT_Counter = 0;
Aborted_Conversion_Counter = 0;

fprintf (1, '    Ход выполнения:\n');

% --- Конвертация присоединенной топологии ---

fprintf (1, '        Конвертация сеток...         ');

% Расшифровка кода исходной сетки
switch Convert_Mesh_From

    case 'PLATE'
        Joint_topology = 'plate';
    case 'PLATE_RBE2_PARALLEL'
        Joint_topology = 'plate_rbe2_parallel';
    case 'PLATE_RBE2_SEQUENTIAL'
        Joint_topology = 'plate_rbe2_sequential';
    case 'RBE2_2D_HOLE'
        Joint_topology = 'rbe2_2d_hole';
    case 'BAR_SPIDER_2D_HOLE'
        Joint_topology = 'bar_spider_2d_hole';
    case 'RBE2_3D_HOLE'
        Joint_topology = 'rbe2_3d_hole';
    case 'BAR_SPIDER_3D_HOLE'
        Joint_topology = 'bar_spider_3d_hole';
    otherwise
        fprintf (1, 'Недопустимое значение параметра Convert_Mesh_From !\n');
        ErrCode = -1;
        return;
        
end

% Цикл по всем болтам
for i=1:size(DB_FASTENERS,1)
    
    % Цикл по ярусам
    for j=1:DB_FASTENERS{i}.N_layers
        
        if (strcmp(DB_FASTENERS{i}.Joint_topology{j}, Joint_topology))
            
            temp_counter_2 = 0;
            
            % Ветвление по типу исходной топологии
            switch Convert_Mesh_From

                case 'PLATE'
                    
                    % Ветвление по типу допустимой целевой топологии
                    switch Convert_Mesh_To                            
                        case 'PLATE_RBE2_PARALLEL'
                            temp_counter_1 = Convert_PL_To_RBE2PAR(i, j, Quad_RBE2_Stiffen_Strategy);
                            if (ErrCode < 0)
                                return;
                            end
                        case 'PLATE_RBE2_SEQUENTIAL'
                            temp_counter_1 = Convert_PL_To_RBE2SEQ(i, j, Quad_RBE2_Stiffen_Strategy);
                            if (ErrCode < 0)
                                return;
                            end
                        otherwise
                            fprintf (1, 'Недопустимое значение параметра Convert_Mesh_To для исходной сетки типа %s !\n', Convert_Mesh_From);
                            ErrCode = -1;
                            return;
                    end
                    
                case 'PLATE_RBE2_PARALLEL'
                    
                    % Ветвление по типу допустимой целевой топологии
                    switch Convert_Mesh_To
                        case 'PLATE'
                            temp_counter_1 = Convert_RBE2PAR_To_PL(i, j);
                            if (ErrCode < 0)
                                return;
                            end
                        case 'PLATE_RBE2_PARALLEL'
                            temp_counter_1 = Convert_RBE2PAR_To_RBE2PAR(i, j, Quad_RBE2_Stiffen_Strategy);
                            if (ErrCode < 0)
                                return;
                            end
                        case 'PLATE_RBE2_SEQUENTIAL'
                            temp_counter_1 = Convert_RBE2PAR_To_RBE2SEQ(i, j, Quad_RBE2_Stiffen_Strategy);
                            if (ErrCode < 0)
                                return;
                            end
                        otherwise
                            fprintf (1, 'Недопустимое значение параметра Convert_Mesh_To для исходной сетки типа %s !\n', Convert_Mesh_From);
                            ErrCode = -1;
                            return;
                    end
                    
                case 'PLATE_RBE2_SEQUENTIAL'
                    
                    % Ветвление по типу допустимой целевой топологии
                    switch Convert_Mesh_To
                        case 'PLATE'
                            [temp_counter_1, temp_counter_2] = Convert_RBE2SEQ_To_PL(i, j);
                            if (ErrCode < 0)
                                return;
                            end
                        case 'PLATE_RBE2_PARALLEL'
                            [temp_counter_1, temp_counter_2] = Convert_RBE2SEQ_To_RBE2PAR(i, j, Quad_RBE2_Stiffen_Strategy);
                            if (ErrCode < 0)
                                return;
                            end
                        case 'PLATE_RBE2_SEQUENTIAL'
                            [temp_counter_1, temp_counter_2] = Convert_RBE2SEQ_To_RBE2SEQ(i, j, Quad_RBE2_Stiffen_Strategy);
                            if (ErrCode < 0)
                                return;
                            end
                        otherwise
                            fprintf (1, 'Недопустимое значение параметра Convert_Mesh_To для исходной сетки типа %s !\n', Convert_Mesh_From);
                            ErrCode = -1;
                            return;
                    end
                    
                case 'RBE2_2D_HOLE'
                    
                    % Ветвление по типу допустимой целевой топологии
                    switch Convert_Mesh_To
                        case 'BAR_SPIDER_2D_HOLE'
                            temp_counter_1 = Convert_RBE2_To_BS(i, j, Bar_Spider_PSet_Name);
                            if (ErrCode < 0)
                                return;
                            end
                        otherwise
                            fprintf (1, 'Недопустимое значение параметра Convert_Mesh_To для исходной сетки типа %s !\n', Convert_Mesh_From);
                            ErrCode = -1;
                            return;
                    end
                    
                case 'BAR_SPIDER_2D_HOLE'
                    
                    % Ветвление по типу допустимой целевой топологии
                    switch Convert_Mesh_To
                        case 'RBE2_2D_HOLE'
                            temp_counter_1 = Convert_BS_To_RBE2(i, j);
                            if (ErrCode < 0)
                                return;
                            end
                        otherwise
                            fprintf (1, 'Недопустимое значение параметра Convert_Mesh_To для исходной сетки типа %s !\n', Convert_Mesh_From);
                            ErrCode = -1;
                            return;
                    end
                    
                case 'RBE2_3D_HOLE'
                    
                    % Ветвление по типу допустимой целевой топологии
                    switch Convert_Mesh_To
                        case 'BAR_SPIDER_3D_HOLE'
                            temp_counter_1 = Convert_RBE2_To_BS(i, j, Bar_Spider_PSet_Name);
                            if (ErrCode < 0)
                                return;
                            end
                        otherwise
                            fprintf (1, 'Недопустимое значение параметра Convert_Mesh_To для исходной сетки типа %s !\n', Convert_Mesh_From);
                            ErrCode = -1;
                            return;
                    end
                    
                case 'BAR_SPIDER_3D_HOLE'
                    
                    % Ветвление по типу допустимой целевой топологии
                    switch Convert_Mesh_To
                        case 'RBE2_3D_HOLE'
                            temp_counter_1 = Convert_BS_To_RBE2(i, j);
                            if (ErrCode < 0)
                                return;
                            end
                        otherwise
                            fprintf (1, 'Недопустимое значение параметра Convert_Mesh_To для исходной сетки типа %s !\n', Convert_Mesh_From);
                            ErrCode = -1;
                            return;
                    end
                    
                otherwise
                    fprintf (1, 'Недопустимое значение параметра Convert_Mesh_From !\n');
                    ErrCode = -1;
                    return;

            end
            
            % Обновление счетчиков
            Converted_JT_Counter = Converted_JT_Counter + temp_counter_1;
            Aborted_Conversion_Counter = Aborted_Conversion_Counter + temp_counter_2;
            
        end
        
    end
    
end

fprintf (1, 'OK!\n');

% --- Вывод статистики ---

fprintf (1, '\n    Статистика:\n');

% Счетчики конвертации присоединенной топологии

fprintf (1, '        Конвертировано сеток типа %s в сетки типа %s: %i\n', Convert_Mesh_From, Convert_Mesh_To, Converted_JT_Counter);
if (Aborted_Conversion_Counter > 0)
    fprintf (1, '        Отменено конвертаций сеток типа PLATE_RBE2_SEQUENTIAL по причине нецентрованности: %i\n', Aborted_Conversion_Counter);
end
